# TanGLe (Shortcut = "Cc Cv T") allows to write the func_compare_simulations.4.R file necessary to then "source()" functions directly from this .org file
    #options(encoding='latin1')


##########################################################################


set_colors<-function(simus_description, names){
transparency	<-50
DOFOCO_color	<-rgb(46,116,156,maxColorValue=255)
IFN_color		<-'grey'
def_colors<-data.frame(
		list_colors=	c('Reds','Oranges', 'Greens', 'Purples', 'Blues','GnBu'),
		list_colors_harv=c(
					rgb(0,0,0,maxColorValue=255),
#					rgb(119,17,34,maxColorValue=255),
					rgb(119,68,17,maxColorValue=255), 
					rgb(17,119,68,maxColorValue=255), 
					rgb(119,17,85,maxColorValue=255), 
					rgb(17,68,119,maxColorValue=255),
					rgb(17,119,119,maxColorValue=255)), 
		list_colors_thin=c(
					rgb(221,119,136,maxColorValue=255),
					rgb(221,170,119,maxColorValue=255), 
					rgb(136,204,170,maxColorValue=255), 
					rgb(204,153,187,maxColorValue=255), 
					rgb(119,170,221,maxColorValue=255),
					rgb(119,204,204,maxColorValue=255)), 
		list_colors_harv_thin=c(
					rgb(170,68,85,maxColorValue=255),
					rgb(170,119,68,maxColorValue=255), 
					rgb(68,170,119,maxColorValue=255), 
					rgb(170,68,136,maxColorValue=255), 
					rgb(68,119,170,maxColorValue=255),
					rgb(68,170,170,maxColorValue=255)), 
		names_cols=		c('none','M', 'O', 'D','U','mix'),
		BaU_harv_val=	c(NA,"1","1","0","0",NA),
		BaU_ccd_val=	c(NA,"0","0","0","0",NA),
		BaU_thin_val=	c(NA,"1","0","0","0",NA)
		)


colors		<-character(1+length(simus_description$runs))
lwds		<-character(1+length(simus_description$runs))
colors[1]	<-IFN_color
lwds[1]		<-1
for(i_scenar in seq_along(names)){
	print(i_scenar)
	scenar		<-	names[i_scenar]
	# Make a matrix with run parameters : one column per mngt category, one line per magt practice
	# Split name of run into its components for M, D, O, U removing the dots
	nchar<-nchar(unlist(strsplit(gsub("[A-Za-z]","",scenar),'_')))
	param_runs	<-	sub("0\\.","",unlist(strsplit(gsub("[A-Za-z]","",scenar),'_')))[1:4]
	#if(length(param_runs[as.numeric(sub('-','',param_runs))>999]) | length(grep('-',param_runs))>0 ){
	if(4 %in% nchar | length(grep('-',param_runs))>0 ){
		# Search which ones have 4 digits (<999) & separate them
		i_temp2	<- which(as.numeric(sub('-','',param_runs))<999)
		temp2	<- sub("([[:digit:]])(-*[[:digit:]])([[:digit:]])$","\\1.\\2.\\3",param_runs[i_temp2])
		# Search which ones have 4 digits (<999) & separate them
		i_temp1	<- which(as.numeric(sub('-','',param_runs))>999)
		temp1	<- gsub("10",".10.",param_runs[i_temp1])
		param_runs[i_temp1]<-temp1	
		param_runs[i_temp2]<-temp2	
		scn_val		<-	data.frame(strsplit(param_runs,"[.]"))
	}else{
		scn_val	<-	data.frame(strsplit(param_runs,""))
	}
	scn_val		<-	t(scn_val[,1:4]	)	
	vec_digits	<-	as.numeric(as.matrix(scn_val))
	intens_max	<-	max(abs(vec_digits)	)
	
	#Search for type of intensification i.e. where the mngt parameters are different than their BaU values
	idx_intens	<- 	as.matrix(which(def_colors[2:5,c('BaU_harv_val','BaU_ccd_val','BaU_thin_val')]!=(scn_val),arr.in=T))

	if(length(idx_intens)==1 & intens_max==1 ){
		if(5 %in% nchar | (!(4%in%nchar) & idx_intens[,'col']==2)){# the 1 is included with a comma-> it is 0.1=>make thin or  the intensification is through ccd reduction
			intens_max<-1
		}else {intens_max<-10}
	}			
	rownames(idx_intens)<-NULL
	
	if(length(idx_intens[,1])==0){				#no idx_intens found => BaU
		idx_col		<- c(1,1)
		scenar_lwd	<- 5
	}else if(length(idx_intens[,1])==1){		#one action of intensification found 
		idx_col		<-as.vector(idx_intens)+c(1,0)
		scenar_lwd	<-intens_max/2
	}else if(length(idx_intens[,1])>1){
		if(length(unique(idx_intens[,1]))==1){	#2 simultaneous intensificication strategies
			idx_col		<-c(unique(idx_intens[,'row'])+1,3)		
			scenar_lwd	<-intens_max/2
		}else{
			idx_col<-c(6,3)
			scenar_lwd	<-intens_max/2
		}
	}
	idx_runs<-  grep(scenar,simus_description$runs )

	scenar_col	<-as.matrix(def_colors[,c('list_colors_harv','list_colors_thin','list_colors_harv_thin')])[idx_col[1],idx_col[2]]
	colors[idx_runs+1]<-as.character(scenar_col)
	lwds[idx_runs+1]<-as.character(scenar_lwd)
	
}
	colors_light=paste(colors,transparency,sep='')
	return(data.frame(colors=colors,colors_light=colors_light,lwds=lwds))

} # end function set_colors
