# Tangle (shortcut = "Cc Cv t") allows to write the .R file necessary to then "source()" functions directly from this .org file
library(frontier)
list_RDI<-NULL
scale='national' # 'national' or 'GRECO'
print('============')
print(paste(' Density indices at scale', scale, 'for dataset',suffx))
print('============')

nplacettes<-0
for (es in species_all$codes){
        # Get a series of information on species "es": number, color code, name, first decile Dg (Dmin), last decile Dg (Dmax)
        es_num  <-as.numeric(gsub("[^0-9]","",es))
        es_color<-as.character(species_all$colors[species_all$codes==es])
        es_color_dark<-as.character(species_all$colors_dark[species_all$codes==es])
        es_name<-as.character(species_all$names[species_all$codes==es])
        print(paste(es,' : ',es_name))
        Dmin=quantile(placette[placette$es_num==es_num,'Dg_ess'],0.1,na.rm=T)
        Dmax=quantile(placette[placette$es_num==es_num,'Dg_ess'],0.9,na.rm=T)
        if(scale=='GRECO'){
## APPROACH by GRECO
                for (reg in GRECO$GRECO_codes){
                        # Select plots of species "es" within the GRECO
                        bd_apply <- placette[placette$GRECO==reg  & (as.vector(as.factor(as.numeric(gsub("[^0-9]","",placette$ess_age_R)))) == as.vector(as.factor(as.numeric(gsub("[^0-9]","",es))))) , ] #bd_calc <- bd_calc[bd_calc$PourcentageG03>0.80,]
                        print(paste('dim(bd_apply)',dim(bd_apply)))
                        # Exclude extreme deciles from previous selection xxVB why are you excluding these deciles? can you shortly explain?
                        bd_calc <- placette[placette$GRECO==reg  & (as.vector(as.factor(as.numeric(gsub("[^0-9]","",placette$ess_age_R)))) == as.vector(as.factor(as.numeric(gsub("[^0-9]","",es))))) &placette$Dg_ess>Dmin& placette$Dg_ess<Dmax, ] #bd_calc <- bd_calc[bd_calc$PourcentageG03>0.80,]
                        #bd_calc<-bd_calc[(as.character(bd_calc$esspre)==as.character(bd_calc$ess_age_R))|is.na(bd_calc$ess_age_R),] # needed because no ess_age_R in 2012 xxVB delete these comments?
                        # Skip species with less than 16 plots in the GRECO
                        if(length(bd_calc$idp)<=15){
                                print(paste('for species', es, 'only ',length(bd_calc$idp),'points. Skipping.'))
                                next
                                }
                        # Determine the parameters of the self-thinning "frontier" function
                        self_thinning<-sfa(log(N_homog)~log(Dg_ess),data=bd_calc)
                        a<-coefficients(self_thinning)[1]
                        b<-coefficients(self_thinning)[2]
                        calc_rdi<-function(N_homog,Dg_ess,a,b){
                                rdi<-N_homog/(exp(a)*Dg_ess^(b))
                                return(rdi)             }
                        bd_apply$a<-a
                        bd_apply$b<-b
                        bd_apply$RDI<-mapply(calc_rdi,bd_apply$N_homog,bd_apply$Dg_ess,a,b)
                        list_RDI<-rbind(list_RDI,bd_apply[,c('idp','esspre','ess_age_R','SER','RDI','a','b')])
                        # Print .pdf file with density indicies of plots
                        filename<-paste('density_indices_',reg,'_',es,'_',suffx,'.pdf',sep='')
                        pdf(filename)
                        plot(log(bd_apply$Dg_ess),log(bd_apply$N_homog),col='grey',xlab='log(Dg_ess)',ylab='log(N_homog)',xlim=c(0,5.5),ylim=c(2,10))
                        points(log(bd_calc$Dg_ess),log(bd_calc$N_homog),col=es_color)
                        abline(v=log(Dmin),lty=3)
                        abline(v=log(Dmax),lty=3)
                #       curve(exp(a)*x^(b),0,max(bd_calc$Dg_ess),add=T,col='red')
                        curve(a+b*x,min(log(bd_apply$Dg_ess)),max(log(bd_apply$Dg_ess)),add=T,col='red')
                        title(paste(es_name,', region ', reg ,sep=''))
                        text(x=max(log(bd_calc$Dg_ess))-0.5,y=max(log(bd_calc$N_homog)),pos=1,label=paste('log(Dg_ess)=',round(a,3),' ',round(b,3),' x log(N_homog)',sep=''))
                        par(fig=c(0.6,1,0.6,1),new=T)
                        hist(bd_apply$RDI)
                        dev.off()
                }#for reg in GRECO
        }#if scale==GRECO

    if(scale=='national'){
                ## APPROACH NATIONAL
                # Select plots of species "es"
                bd_apply<- placette[placette$es_num== es_num  , ]
                # Exclude extreme deciles from previous selection xxVB why are you excluding these deciles? can you shortly explain?
                bd_calc <- placette[!is.na(placette$Dg_ess)  & placette$es_num == es_num & placette$Dg_ess>Dmin & placette$Dg_ess<Dmax, ]
                print(paste('dim(bd_calc)',dim(bd_calc)[1]))
                print(paste('dim(bd_apply)',dim(bd_apply)[1]))
                nplacettes<-nplacettes+dim(bd_apply)[1]
                # Skip species with less than 16 plot
                if(length(bd_calc$idp)<=15){
                        print(paste('for species', es, 'only ',length(bd_calc$idp),'points. Skipping.'))
                        next
                }
                # Determine the parameters of the self-thinning "frontier" function
                self_thinning<-sfa(log(N_homog)~log(Dg_ess),data=bd_calc)
                intrc<-coefficients(self_thinning)['(Intercept)']
                slope<-coefficients(self_thinning)['log(Dg_ess)']
        print(intrc)
        print(slope)
                calc_rdi<-function(N_homog,Dg_ess,slope,intrc){
                        rdi<-N_homog/(exp(intrc)*Dg_ess^(slope))
                return(rdi)             }
                bd_apply$intrc  <-intrc
                bd_apply$slope  <-slope
                bd_calc$RDI             <-mapply(calc_rdi,bd_calc$N_homog,bd_calc$Dg_ess,slope,intrc)
                bd_apply$RDI    <-mapply(calc_rdi,bd_apply$N_homog ,bd_apply$Dg_ess ,slope,intrc)
# #             Shift up to most dense point
                # datamax<-bd_calc[bd_calc$RDI==max(bd_calc$RDI,na.rm=T) & !is.na(bd_calc$RDI),]
                # intrc_shift<-log(datamax$N_homog)-slope*log(datamax$Dg_ess)
                # bd_apply$intrc_shift<-intrc_shift
                # bd_apply$b                    <-slope
                # bd_apply$RDI_shift    <-mapply(calc_rdi ,bd_apply$N_homog ,bd_apply$Dg_ess , intrc_shift,slope)
                # bd_calc$RDI_shift     <-mapply(calc_rdi,bd_calc$N_homog,bd_calc$Dg_ess, intrc_shift, slope) xxVB delete all this?
                # ###########
                list_RDI<-rbind(list_RDI,bd_apply[,c('idp','esspre','ess_age_R','SER','RDI','intrc','slope')])
                # Print .pdf file with density indicies of plots
                filename<-paste(RDI_DIR,'density_indices_',es,'_N_homog_Dg_ess.pdf',sep='')
                pdf(filename)
                plot(log(bd_apply$Dg_ess),log(bd_apply$N_homog),col='grey',xlab='log(Dg_ess)',ylab='log(N_homog)',xlim=c(1,5.5),ylim=c(2,10))
                points(log(bd_calc$Dg_ess),log(bd_calc$N_homog),col=es_color)
                abline(v=log(Dmin),lty=3)
                abline(v=log(Dmax),lty=3)
#               curve(exp(intrc+slope*log(x)    )               ,min((bd_apply$Dg_ess),na.rm=T),max((bd_apply$Dg_ess),na.rm=T),add=T,col='red') xxVB delete?
                curve(intrc+slope*x                     ,min(log(bd_apply$Dg_ess),na.rm=T),max(log(bd_apply$Dg_ess),na.rm=T),add=T,col='red')
#               curve(intrc_shift+slope*x       ,min(log(bd_apply$Dg_ess),na.rm=T),max(log(bd_apply$Dg_ess),na.rm=T),add=T,col='red') xxVB delete?
                title(paste(es_name,', France ',sep=''))
                text(x=1,y=9.,pos=1,label=paste('ndata: ',length(bd_calc$age_1),'/',length(bd_apply$age_1),'\n log(N_homog)=',round(slope,3),' ',round(intrc,3),' x log(Dg_ess)',sep=''),cex=0.8)
                par(fig=c(0.6,1,0.6,1),new=T)
                hist(bd_apply$RDI,col=es_color,xlim=c(0,4))
                dev.off()
}#end if scale==national
}

write.csv(list_RDI,paste(RDI_DIR,'list_RDI_N_homog_Dg_ess_noshift.csv',sep=""))
#placette<-merge(placette, list_RDI[,c('idp','RDI')], by='idp', all.x=TRUE) xxVB delete?
