#################################################################
#                                                                                                                               #
#                       Calculate Site indexes                                                          #
#                                                                                                                               #
#                                                                                                                               #
#                       @ Aude Valade, adapted from Patrick Vallet                      #
#                                                                                                                               #
#                                                                                                                               #
#################################################################
library(nlme)
# Reference age for fertility index (years)
age_ref                 <-100
list_H100               <- NULL
list_coefs_SI   <- NULL
var_age                 <-'age_1' # CHANGE also in modhoss
plot                    <-'yes'
#list_h0                        <- read.table(paste(DATA_DIR,'list_h0.txt',sep=''),sep=';',h=T,colClasses=c("factor", "factor","numeric")) xxVB delete?
# Read dominant height (h0) from pre-existing calculation. Dominant height (in meters) is defined as the average height of the 100 highest trees per hectare.
list_h0                 <- read.table(paste(DATA_DIR,'1-Donnees_IGN/H0_par_IDP_EsparR.txt',sep=''),sep=';',h=T,colClasses=c("numeric","factor", "factor","numeric","factor","factor","factor"))
list_h0$esparR  <-as.numeric(gsub("[^0-9]","",list_h0$esparR))
# Replace list_h0 with the average h0 per plot and per species
list_h0                 <- aggregate(h0~idp+esparR,data=list_h0,mean)
#list_h0$type   <-ifelse(as.numeric(gsub("[^0-9]","",list_h0$espar))>50,type<-'R',type<-'F')
#list_h0$esparR<- mapply(findresiduals, list_h0$espar, list_h0$type)    #no esspre var in arbre db but been merged with placette db
#write.table(list_h0_PV,paste(DATA_DIR,'H0_par_IDP_EsparR.txt',sep=''),sep=';') xxVB delete

suffx                   <-'withNR'
placette$es_num <-as.numeric(gsub("[^0-9]","",placette$ess_age_R))
placette$H100   <-NA

for (es in species_all$es_num){
        print(es)
        a<-NA;b<-NA;d<-NA
        SI_curve_h0     <-NULL
        modhoss         <-NULL
        es_color        <-as.character(species_all$colors[species_all$es_num==es])
        #Some plots have two values of h0. Take the one for the right species
        bd_es           <- merge(placette[placette$es_num == es , ] , list_h0[as.numeric(gsub("[^0-9]","",list_h0$esparR))==es , ], by="idp")

        ## 1 - Subset of data per stand structure (0=undefined, 1=even-aged high stand, 2=uneven-aged high stand, 3=mixed high stand and coppice, 4=coppice) and per species xx2
        # Stand structures with fewer than 25% of plots for species "es" are bundled together for the determination of H100 xxVB c'est bien ça ?
        # For species n°6, all stand structures are grouped xxVB donner le nom de l'essence et expliquer
        data_sfo1       <- placette[
                                        (placette$sfo=='1' | placette$sfo=='2')&
                                        placette$es_num == es ,]
        data_sfo3       <- placette[
                                        placette$sfo=='3'&
                                        placette$es_num == es ,]
        data_sfo4       <- placette[
                                        placette$sfo=='4'&
                                        placette$es_num == es ,]
        list_sfo        <- NULL
        n_tot           <- length(data_sfo1$idp)+length(data_sfo3$idp)+length(data_sfo4$idp)
        n_max           <- max(length(data_sfo1$idp),length(data_sfo3$idp),length(data_sfo4$idp))

        if(length(data_sfo1$idp) > 0.25*n_tot){
                list_sfo<-append(list_sfo,c(1))
                }
        if(length(data_sfo3$idp) > 0.25*n_tot){
                list_sfo<-append(list_sfo,3)
                }
        if(length(data_sfo4$idp) > 0.25*n_tot){
                list_sfo<-append(list_sfo,4)
        }

        if(es=='6'){list_sfo<-1}

        if(plot=='yes'){
                filename<-paste(H100_DIR,'site_indices_',es,'_',var_age,'_',suffx,'.pdf',sep='')
                pdf(filename,width=15)
                par(mfrow=c(1,length(list_sfo)))
        }
        # xx VB not sure what you are doing here. Can you put a comment?
        for(i_sfo in list_sfo){
                seek_sfo<-i_sfo
                if(i_sfo==1){
                        seek_sfo<-append(seek_sfo,c(0,2))
                        if(!(3 %in%list_sfo)){
                                seek_sfo<-append(seek_sfo,3)
                                if(!(4 %in% list_sfo)){
                                        seek_sfo<-append(seek_sfo,4)
                                }
                        }
                }
                if(i_sfo==3){
                        if(!(1 %in%list_sfo)){
                                seek_sfo<-append(seek_sfo,c(0,1,2))
                        }
                        if( !(4 %in%list_sfo)){
                                seek_sfo<-append(seek_sfo,4)
                         }
                }
                if(i_sfo==4){
                        if(!(1 %in%list_sfo) & !(3 %in%list_sfo)){
                                seek_sfo<-append(seek_sfo,c(0,1,2,3))
                        }
                }

                #------which data to apply the relationships on
                bd_sfo <- placette[
                                        !is.na(placette$age_1)&
                                        placette$sfo %in% seek_sfo &
                                        placette$es_num ==es , ]
                bd_sfo <- merge(bd_sfo, list_h0[as.numeric(gsub("[^0-9]","",list_h0$esparR))==es & (list_h0$idp %in% bd_sfo$idp) , ], by="idp")

                print(paste(length(bd_sfo$idp)))
                if(length(bd_sfo$idp)==712 | length(bd_sfo$idp)==713){print('!!!!!!!!!!!')}
                #------which data to use for retrieving relationships
                bd_sfo_calc<-  bd_sfo[
                                        bd_sfo$sfo== i_sfo  &
                                        bd_sfo[,c(var_age)]<250 &
                                        bd_sfo[,c(var_age)]>10 &
                                        bd_sfo $cac!="AA" &
                                        bd_sfo $cac!="NR"&
                                        !is.na(bd_sfo[,c(var_age)]) ,]
                i_test  <-0
                modhoss <-NULL
                if(es==10){dstart<-1.6}else{dstart<-1.2}
                if(i_sfo==4){
                        bstart<-29 #28
                }else{
                        bstart<-17 #19
                }

                #xxVB ici visiblement tu fittes des courbes sur les 98 premiers percentiles de ta sélection mais ça mériterait une petite explication (pourquoi les percentiles ? quelle procédure ?)
                startpoints<-c(
                                a=floor(as.numeric(quantile(bd_sfo_calc$h0,0.98)) ) ,
                                b=bstart,
                                d=dstart)
                while(i_test==0 | ('try-error' %in% class(modhoss) ) ){
                        startpoints['b']<-startpoints['b']+1
                        print(paste('try fitting iteration :',i_test))
                        i_test<-i_test+1
                        modhoss <-try(gnls(h0 ~ (a)/(1+(b/age_1)^d), data = bd_sfo_calc[,c('age_1','h0')], start=startpoints,   weights = varPower(form = ~ age_1)),silent=T)
                }

                a<-coef(modhoss)[1]
                b<-coef(modhoss)[2]
                d<-coef(modhoss)[3]
                list_coefs_SI<-rbind(list_coefs_SI,c(es,a,b,d))


                guide_curve_h0<-function(age,a,b,d){
                        h0<-(a)/(1+(b/age)^d)
                        return(as.numeric(h0))
                }

                ## 3 - Functions to get SI from guide curve.
                ##The general equation derived for the guide curve can be propagated to another (h0,age) point by assuming
                ##that Hdom_guide(ref_age)/ Hdom_guide(t)= Hdom_S(ref_age)/ Hdom_S(t), where Hdom_guide(ref_age)=site index
                ##of the guide curve derived from guide curve equation, Hdom_guide(t)=the h0 read in guide curve for the age
                ##measured that we get from the data, Hdom_S(ref_age)= site index we search, Hdom_S(t) is the h0 measured that
                ##we get from the data. This gives the site indices for all plots based on their dominant height and age.

                # Function to obtain site index as a function of dominant height and age, based on fitted guide_curve
                calc_SI<-function(h0,age){
                        SI<-h0*guide_curve_h0(age_ref,a,b,d)/guide_curve_h0(age,a,b,d)
                }

                # Function to predict domindant height based on site index and age, based on fitted guide_curve
                SI_curve_h0<-function(age, SI){
                        h0<-SI/guide_curve_h0(age_ref,a,b,d)*guide_curve_h0(age,a,b,d)
                }

                bd_sfo$H100     <- mapply(calc_SI,bd_sfo$h0, bd_sfo[,c(var_age)])
                bd_sfo_calc$H100 <- mapply(calc_SI,bd_sfo_calc$h0, bd_sfo_calc[,c(var_age)])
                SImin           <- sort(bd_sfo_calc$H100,TRUE)[10]
                SImax           <- sort(bd_sfo_calc$H100,FALSE)[10]
                SImed           <- SImin+(SImax-SImin)/2
                bd_sfo[ bd_sfo$H100 > mean(bd_sfo$H100,na.rm=T)*4,'H100'] <- max(bd_sfo[!(bd_sfo$H100>mean(bd_sfo$H100,na.rm=T)*4),'H100'],na.rm=T)

                placette[placette$idp %in% bd_sfo$idp,'H100'] <- merge(placette[c('V','idp')],bd_sfo[,c('idp','H100')],by='idp')[c('H100')]


                if(plot=='yes'){
                        plot(bd_es$h0 ~ bd_es[,c(var_age)], xlim=c(0, 250), ylim=c(0,45),xlab='Stand age (years)',ylab='Dominant height (m)',col='darkgrey')
                        points(bd_sfo$h0 ~ bd_sfo[,c(var_age)], xlim=c(0, max(bd_sfo[,c(var_age)])), ylim=c(0,45),xlab='Stand age (years)',ylab='Dominant height (m)',col='black')
                        points(bd_sfo_calc$h0 ~ bd_sfo_calc[,c(var_age)], xlim=c(0, max(bd_sfo[,c(var_age)])), ylim=c(0,45),xlab='Stand age (years)',ylab='Dominant height (m)',col=es_color)

                        title(paste(species_all$remove_accents.names.[species_all$es_num==es],'(',es, '), sfo :',i_sfo))

                        x <- seq(0, max(bd_es[,c(var_age)],na.rm=T), 0.2)
                        lines(x,SI_curve_h0(x,SImin),col='black')
                        lines(x,SI_curve_h0(x,SImax),col='black')
                        lines(x,SI_curve_h0(x,SImed),col='black',lwd=2)

                        lines(x,SI_curve_h0(x,((SImax-SImin)/2+SImin)),  col='black')
                        lines(x,SI_curve_h0(x,((SImax-SImin)/3+SImin)),  col='black')
                        lines(x,SI_curve_h0(x,(2*(SImax-SImin)/3+SImin)),col='black')
                        lines(x,SI_curve_h0(x,((SImax-SImin)/4+SImin)),  col='black')
                        lines(x,SI_curve_h0(x,(3*(SImax-SImin)/4+SImin)),col='black')

                        mtext(paste('median site index H100:' ,round(SImed,3),'m \n fitted on data subset for list_sfoure sfo ',i_sfo),side=1)
                        #par(fig=c(0.6,1,0.6,1),new=T)
                        #hist(bd_sfo$H100, breaks=seq(0, 50, 2))

                }# end if plot=='yes'
        list_H100<-rbind(list_H100,bd_sfo[,c('idp','H100','sfo')])

        }# end for i_sfo

        if(plot=='yes'){dev.off()}

}#end for es

# xxVB a write was missing. I put this one:
write.csv(list_H100,paste(H100_DIR,'list_H100_age_1_sfo_diff.2.csv',sep=""))

#xxVB delete all what follows?
# #

# # #
# # #### ADJUSTMENT of parameters

 # # # # # # ###### Test for adjustment of gnls start ###
                 # for(a in seq(28,28,by=1)){
                        # for(b in seq(18,18,by=1)){
                                # for(d in seq(1.2,1.2,by=0.1)){
                                        # print(paste(a,' ',b,' ',d))
                                        # modhoss<-NULL
                                         # modhoss <- try(gnls(h0 ~ (a)/(1+(b/age_1)^d),  data = bd_sfo_calc, start=c(a = a, b= b,d=d),   weights = varPower(form = ~ age_1)))
                                        # if(length(modhoss)!=0 & !('try-error' %in% class(modhoss) ) ){
                                                # print('!!!!!!!!!!!!!!!')
                                                # print('!!!!!!!!!!!!!!!')
                                                # print('!!!!!!!!!!!!!!!')
                                                # }

                                # }
                        # }
                 # }
# #                  plot(bd_es$h0 ~ bd_es[,c(var_age)], xlim=c(0, max(bd_es[,c(var_age)])),ylim=c(0,45), col='black',xlab='Stand age (years)',ylab='Dominant height (m)')
                     # plot(bd_es$h0 ~ bd_es[,c(var_age)], xlim=c(0, 140),ylim=c(0,45), col='grey',xlab='Stand age (years)',ylab='Dominant height (m)')
                     # points(bd_sfo_calc$h0 ~ bd_sfo_calc[,c(var_age)],  col=es_color,xlab='Stand age (years)',ylab='Dominant height (m)')
                     # a=29.49984
                     # b=28.66874
                     # d=1.213123
                     # x<-seq(0,140,1)
                     # y<-(a)/(1+(b/x)^d)
                     # points(x,y)
                     # curve((a)/(1+(b/x)^d),0,400,add=T)
