# Tangle (shortcut = "Cc Cv t") allows to write the F-function_init_IGN.R file necessary to then "source()" functions directly from this .org file

source(paste(CODE_DIR,'F-functions_implementation.6.R',sep=""))
boost<-''

if(plot_diag_fig=='yes'){list_plot_es<-species_all$codes}
if(plot_diag_fig=='partial'){list_plot_es<-list_partial_plot}

if(dim(bilanapresM)[2]!=0){
    VmaxM     <-num(max(bilanapresM[,,'V'],      na.rm=T))
    Dg_essmaxM<-num(max(bilanapresM[,,'Dg_ess'], na.rm=T))
    RDImaxM   <-num(max(bilanapresM[,,'RDI'],    na.rm=T))
    IV5maxM   <-num(max(bilanapresM[,,'IV5'],    na.rm=T))
    ir5_essmaxM   <-num(max(bilanapresM[,,'ir5_ess'],    na.rm=T))
    agemaxM   <-300
}else{VmaxM<-NA; Dg_essmaxM<-NA; RDImaxM<-NA; IV5maxM<-NA; agemaxM<-NA; ir5_essmaxM<-NA}

if(dim(bilanapresO)[2]!=0){
    VmaxO     <-num(max(bilanapresO[,,'V'],      na.rm=T))
    Dg_essmaxO<-num(max(bilanapresO[,,'Dg_ess'], na.rm=T))
    RDImaxO   <-num(max(bilanapresO[,,'RDI'],    na.rm=T))
    IV5maxO   <-num(max(bilanapresO[,,'IV5'],    na.rm=T))
    ir5_essmaxO   <-num(max(bilanapresO[,,'ir5_ess'],    na.rm=T))
    agemaxO   <-300
}else{VmaxO<-NA; Dg_essmaxO<-NA; RDImaxO<-NA; IV5maxO<-NA; agemaxO<-NA; ir5_essmaxO <-NA}

if(dim(bilanapresD)[2]!=0){
    VmaxD     <-num(max(bilanapresD[,,'V'],      na.rm=T))
    Dg_essmaxD<-num(max(bilanapresD[,,'Dg_ess'], na.rm=T))
    RDImaxD   <-num(max(bilanapresD[,,'RDI'],    na.rm=T))
    IV5maxD   <-num(max(bilanapresD[,,'IV5'],    na.rm=T))
    ir5_essmaxD   <-num(max(bilanapresD[,,'ir5_ess'],    na.rm=T))
    agemaxD   <-300
}else{VmaxD<-NA; Dg_essmaxD<-NA; RDImaxD<-NA; IV5maxD<-NA; agemaxD<-NA; ir5_essmaxD <-NA}

if(dim(bilanapresU)[2]!=0){
    VmaxU     <-num(max(bilanapresU[,,'V'],      na.rm=T))
    Dg_essmaxU<-num(max(bilanapresU[,,'Dg_ess'], na.rm=T))
    RDImaxU   <-num(max(bilanapresU[,,'RDI'],    na.rm=T))
    IV5maxU   <-num(max(bilanapresU[,,'IV5'],    na.rm=T))
    ir5_essmaxU   <-num(max(bilanapresU[,,'ir5_ess'],    na.rm=T))
    agemaxU   <-300
}else{VmaxU<-NA; Dg_essmaxU<-NA; RDImaxU<-NA; IV5maxU<-NA; agemaxU<-NA; ir5_essmaxU<-NA}

Vmax      <-as.numeric(max(VmaxM,VmaxO,VmaxD,VmaxU,na.rm=T))
Dg_essmax <-as.numeric(max(Dg_essmaxM, Dg_essmaxO, Dg_essmaxD,Dg_essmaxU,na.rm=T))
RDImax    <-as.numeric(max(RDImaxM,RDImaxO,RDImaxD,RDImaxU,na.rm=T))
IV5max    <-as.numeric(max(IV5maxM,IV5maxO,IV5maxD,IV5maxU,na.rm=T))
ir5_essmax    <-as.numeric(max(ir5_essmaxM, ir5_essmaxO, ir5_essmaxD, ir5_essmaxU,na.rm=T))
agemax    <-as.numeric(max(agemaxM,agemaxO,agemaxD,agemaxU,na.rm=T))
listmax<-data.frame(V= Vmax,Dg_ess= Dg_essmax,RDI= RDImax,IV5= IV5max,ir5_ess= ir5_essmax,age=agemax)
bilanapresall<-abind(abind(abind(bilanapresM, bilanapresU,along=2), bilanapresO,along=2),bilanapresD,along=2)


for(es in list_plot_es){
    print(es)
    es_num<-as.vector(as.factor(as.numeric(gsub("[^0-9]","",es))))

    if(es_num %in% bilanapresM[,,'ess_age_R']){
        print(es)
        print(paste('plotting diag figures for es:',es))
        ccd_cat         <- as.numeric   (species_all[species_all$codes==es,c('clear_cut_diam1','clear_cut_diam2','clear_cut_diam3','clear_cut_diam4')])

        pdf(paste(OUT_SIM_DIR,'BiCaFF_out_',es,'_',suffx,'_scatter.pdf',sep=''),width=28,height=20)
        print('---Scatterplots')
        par(mfrow=c(4,6), oma=c(6,5,8,5),mar=c(6,4,4,4)) # bottom,left,top,right
        if(dim(bilanapresM)[2]>1){
            plot_diag(init, bilanapresM,c('V','IV5','Dg_ess','ir5_ess','RDI'),tmax,listmax,'managed',boost,es_num, ccd_cat)
            title(main=table(init$cat),outer=T)
        }
        if(dim(bilanapresO)[2]>1){
            plot_diag(init, bilanapresO,c('V','IV5','Dg_ess','ir5_ess','RDI'),tmax ,listmax,'overstocked',boost,es_num, ccd_cat)
        }
        if(dim(bilanapresD)[2]>1){
            plot_diag(init, bilanapresD,c('V','IV5','Dg_ess','ir5_ess','RDI'),tmax ,listmax,'harvest-delayed',boost,es_num, ccd_cat)
        }
        if(dim(bilanapresU)[2]>1  ){
            plot_diag(init, bilanapresU,c('V','IV5','Dg_ess','ir5_ess','RDI'),tmax ,listmax,'unexploitable',boost,es_num, ccd_cat)
        }
        dev.off()

        pdf(paste(OUT_SIM_DIR,'BiCaFF_out_',es,'_',suffx,'_hist.pdf',sep=''),width=21,height=30)
        print('---Histograms')
        par(mfrow=c(4,5), oma=c(6,5,8,5),mar=c(6,4,4,4)) # bottom,left,top,right

        bilanapresall<-bilanapresM
        t_checkM        <-as.data.frame(bilanapresM[2,,])
        endM            <-as.data.frame(bilanapresM[tmax+1,,])
        print('M')
        plot_hist(init, t_checkM ,endM, 'V (m3/ha)',     tmax,ccd_cat,'managed',es_num)
        # Je suis pas sûr de comprendre à quoi correspondent les trois histogrammes de plot_hist, et du coup les 5 couleurs (blanc, noir, gris foncé, vert foncé, vert clair). Mais ça vaudrait le coup de légender les 5 couleurs, au moins sur le premier graphe.
        ## legend("topleft",
        plot_hist(init, t_checkM ,endM, 'IV5 (m3/ha/5yrs)',   tmax,ccd_cat,'',es_num)
        plot_hist(init, t_checkM ,endM, 'Dg_ess (cm)',tmax,ccd_cat,'',es_num)
        plot_hist(init, t_checkM ,endM, 'RDI',   tmax,ccd_cat,'',es_num)
        plot_hist(init, t_checkM ,endM, 'age_1 (yrs)',   tmax,ccd_cat,'',es_num)

        t_checkO        <-as.data.frame(bilanapresO[2,,])
        endO            <-as.data.frame(bilanapresO[tmax+1,,])
        if(length(endO$age_1)>0){
            print('O')
            plot_hist(init, t_checkO ,endO, 'V (m3/ha)',     tmax,ccd_cat,'overstocked',es_num)
            plot_hist(init, t_checkO ,endO, 'IV5 (m3/ha/5yrs)',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkO ,endO, 'Dg_ess (cm)',tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkO ,endO, 'RDI',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkO ,endO, 'age_1 (yrs)',   tmax,ccd_cat,'',es_num)
        }
        t_checkD        <-as.data.frame(bilanapresD[2,,])
        endD            <-as.data.frame(bilanapresD[tmax+1,,])
        if(length(endD$age_1)>0){
            print('D')
            plot_hist(init, t_checkD ,endD, 'V (m3/ha)',     tmax,ccd_cat,'harvestdelayed',es_num)
            plot_hist(init, t_checkD ,endD, 'IV5 (m3/ha/5yrs)',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkD ,endD, 'Dg_ess (cm)',tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkD ,endD, 'RDI',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkD ,endD, 'age_1 (yrs)',   tmax,ccd_cat,'',es_num)
        }
        t_checkU        <-as.data.frame(bilanapresU[2,,])
        endU            <-as.data.frame(bilanapresU[tmax+1,,])
        if(length(endU$age_1)>0){
            print('U')
            plot_hist(init, t_checkU ,endU, 'V (m3/ha)',     tmax,ccd_cat,'unexploitable',es_num)
            plot_hist(init, t_checkU ,endU, 'IV5 (m3/ha/5yrs)',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkU ,endU, 'Dg_ess (cm)',tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkU ,endU, 'RDI',   tmax,ccd_cat,'',es_num)
            plot_hist(init, t_checkU ,endU, 'age_1 (yrs)',   tmax,ccd_cat,'',es_num)
        }
        dev.off()

        pdf(paste(OUT_SIM_DIR,'BiCaFF_out_',es,'_',suffx,'_evol.pdf',sep=''),width=21,height=30)
        print('---Evolutions')
        par(mfrow=c(5,4), oma=c(6,5,8,5),mar=c(6,4,4,4)) # bottom,left,top,right
        plot_vol(df_bilan_volumes, es_num,'volM_ha',tmax)
        plot_vol(df_bilan_volumes, es_num,'vharvM_hs_ha',tmax)
        plot_vol(df_bilan_volumes, es_num,'vharvM_co_ha',tmax)
        plot_vol(df_bilan_volumes, es_num,'vthinM_ha',tmax)
        if(dim(bilanapresO)[2]>1){
            plot_vol(df_bilan_volumes, es_num,'volO_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vharvO_hs_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vharvO_co_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vthinO_ha',tmax)
        }
        if(dim(bilanapresD)[2]>1){
            plot_vol(df_bilan_volumes, es_num,'volD_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vharvD_hs_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vharvD_co_ha',tmax)
            plot_vol(df_bilan_volumes, es_num,'vthinD_ha',tmax)
        }
        if(dim(bilanapresU)[2]>1  ){
            plot_vol(df_bilan_volumes,es_num,'volU_ha',tmax)
            plot_vol(df_bilan_volumes,es_num,'vharvU_hs_ha',tmax)
            plot_vol(df_bilan_volumes,es_num,'vharvU_co_ha',tmax)
            plot_vol(df_bilan_volumes,es_num,'vthinU_ha',tmax)
        }
        bilanapresall<-abind(abind(abind(bilanapresM, bilanapresU,along=2), bilanapresO,along=2),bilanapresD,along=2)
        t_check <-as.data.frame(bilanapresall[2,,])
        end             <-as.data.frame(bilanapresall[tmax+1,,])
        plot_France_vol(df_bilan_volumes[df_bilan_volumes$es==es,],es,'vol')
        plot_France_vol(df_bilan_volumes[df_bilan_volumes$es==es,],es,'vharv_hs')
        plot_France_vol(df_bilan_volumes[df_bilan_volumes$es==es,],es,'vharv_co')
        dev.off()

    }# end fi es in dataset
}#end for es in species
