# TanGLe (Shortcut = "Cc Cv T") allows to write the func_compare_simulations.4.R file necessary to then "source()" functions directly from this .org file
    #options(encoding='latin1')
  # =================== load required libraries, define environment =================== 
library(abind)
library(RColorBrewer)
library(scales)
library(viridis)
library(gtools)
library(ggplot2)
library(lattice)# needed for histogram as a lattice object that can be 'printed' with spplot objects
library(sp)
library(plyr) # for function rename and arrange
library(reshape) # for function melt

source(paste(CODE_DIR,"func_compare_simulations.4.R",sep=""))
source(paste(CODE_DIR,"F-function_init_IGN.R",sep=""))

#Fate of extra bibe 
r_bibe	<- 0
expt	<- 0
# =================== define paths and read IFN and output files =================== 

AREAS_DIR		<-'/Users/valade/EcoSols_Nextcloud/Foret_francaise/BiCaFF/code_modele_share_VB/Input_datasets/1-Donnees_IGN/'
Dofoco_DIR		<-'~/R_files/R_Dofoco/ACLFfFrFM1/'
BiCaFFprefxIN	<-'BiCaFF_out_'
BiCaFFprefxIN2	<-'BiCaFF_out'

MOD_DIR			<-'/Users/valade/EcoSols_Nextcloud/Foret_francaise/BiCaFF/code_modele_share_VB/Outputs/'
#MOD_DIR			<-'~/WORK_Projets/BiCaFF/MODEL_emacs/code_modele_share/Outputs/'
list			<-list.files(path=paste(MOD_DIR,'run_details',sep=''))
run_files		<-paste(MOD_DIR,'run_details/' ,list[grep('run_details',list)],sep='')

# MOD_DIR			<-'./0-MODEL_Empirical/'
# list			<-list.files(path=paste(MOD_DIR,'/run_details/',sep=''))
# run_files		<-paste(MOD_DIR ,'/run_details/',list[grep('run_details',list)],sep='')
# 
last_run		<-run_files[which.min(as.vector(difftime(Sys.time(),file.info(run_files)[,'ctime'])))]
pref			<-sub("_M.*","",last_run)
job_name		<-sub(".*out_","",pref)
tmax			<-as.numeric(sub("_prog.*","",sub(".*_t","",job_name)))

#---- Or customize job and/or time for plot
#job_name		<-"national_wedges.2_t30_prog30_bibe0_expt0_sensi0" 
#tmax <- 100
tmax <- 40
#---- 
t_plot<-min(tmax,200) # horizon temporel des figures

print(paste('Reading results for job name:',job_name))

SIM_DIR			<- paste(MOD_DIR,job_name,'/',sep='')
OUT_DIR_base	<- paste(MOD_DIR, job_name,'_',t_plot,'/',sep='')
OUT_DIR	<- paste(OUT_DIR_base,'newpostproc/',sep='')
OUT_DIR_species	<- paste(OUT_DIR,'species/',sep='')

# OUT_DIR_base			<- paste('~/R_files/0-MODELS_compare/', job_name,'_',t_plot,'/',sep='')
# OUT_DIR	<- paste(OUT_DIR_base,'newpostproc/',sep='')
# OUT_DIR_species	<- paste(OUT_DIR,'species/',sep='')

out_prefx		<- paste(job_name,'_test',sep='')

dir.create(OUT_DIR_base, 		showWarnings = FALSE)
dir.create(OUT_DIR, 		showWarnings = FALSE)
dir.create(OUT_DIR_species, showWarnings = FALSE)

areas_by_species <-read.table(																					
		paste(AREAS_DIR,'areas_all_species_GRECO_data_standard_residuals_filled_out.csv',sep=''),					
		sep=';',header=T, colClasses= c("factor","factor","factor","factor", rep("numeric", 5),'factor'))			
areas_by_species$IFN_vol		<-areas_by_species$IFN_vol*10^6	
areas_by_species$IFN_prod_tot	<-areas_by_species$IFN_prod_tot*10^6	
areas_by_species$es_num			<-as.vector(as.factor(as.numeric(gsub("[^0-9]","",areas_by_species$es))))
areas_by_species$es				<-as.vector(as.factor(as.numeric(gsub("[^0-9]","", areas_by_species$es))))

GRECO           <- read_GRECO()
species_all		<- init_species_all()
df_colnames<-c('runs','time','GRECO','es','prod_ha','prod_tot','harv_ha','harv_tot','vol_ha','vol_tot','type','dataset')#,'area')
df_colnames_full<-c(df_colnames,'M','O','D','U','scenar')

# ==================================================================
# =================== choose simulations to plot =================== 


simus			<-c('IFN','BiCaFF')
if('DOFOCO' %in% simus){
	job_name_DOFOCO<-'ACLFfFrFM1'
}
	
#Always start names list with BaU	
i_BaU <- 1
scenar<-c(
  'M101_O100_D000_U000',
#  'M000_O000_D000_U000',

   'M101_O100_D100_U000',
	 # 'M101_O100_D0.900_U000',
	 # 'M101_O100_D0.800_U000',
	 # 'M101_O100_D0.700_U000',
	 # 'M101_O100_D0.600_U000',
	 # 'M101_O100_D0.500_U000',
	 # 'M101_O100_D0.400_U000',
	 # 'M101_O100_D0.300_U000',
	 # 'M101_O100_D0.200_U000',
	 # 'M101_O100_D0.100_U000',

	'M101_O101_D000_U000',
# 	'M101_O100.9_D000_U000',
# 	'M101_O100.8_D000_U000',
# 	'M101_O100.7_D000_U000',
# 	'M101_O100.6_D000_U000',
# 	'M101_O100.5_D000_U000',
# 	'M101_O100.4_D000_U000',
# 	'M101_O100.3_D000_U000',
# 	'M101_O100.2_D000_U000',
#  	'M101_O100.1_D000_U000',

	'M1101_O100_D000_U000'#,
# 	'M191_O100_D000_U000',
# 	'M181_O100_D000_U000',
# 	'M171_O100_D000_U000',
# 	'M161_O100_D000_U000',
# 	'M151_O100_D000_U000',
# 	'M141_O100_D000_U000',
# 	'M131_O100_D000_U000',
# 	'M121_O100_D000_U000',
#  	'M111_O100_D000_U000',

# 'M191_O100.9_D0.900_U000',
# 'M181_O100.8_D0.800_U000',
# 'M171_O100.7_D0.700_U000',
# 'M161_O100.6_D0.600_U000',
# 'M151_O100.5_D0.500_U000',
# 'M141_O100.4_D0.400_U000',
# 'M131_O100.3_D0.300_U000',
# 'M121_O100.2_D0.200_U000',
# 'M111_O100.1_D0.100_U000',
#'M1101_O101_D100_U000'

	)
	
scenar_df<-data.frame(t(matrix(unlist(strsplit(gsub("[A-Z]","",scenar),'_')),nrow=4,ncol=length(scenar))))
colnames(scenar_df)<-c('M','O','D','U')
scenar_df$runs<-scenar
scenar_df$D<-gsub('00','',scenar_df$D)
scenar_df$M<-sub('1','',scenar_df$M) 
scenar_df$Mdiff<-as.numeric(as.vector(as.numeric(scenar_df$M))-as.vector(as.numeric(scenar_df$M[1])))/10
scenar_df$Odiff<-as.numeric(as.vector(as.numeric(as.vector(scenar_df$O))-as.numeric(as.vector(scenar_df$O[1]))))*10
scenar_df$Ddiff<-as.numeric(as.vector(as.numeric(as.vector(scenar_df$D))-as.numeric(as.vector(scenar_df$D[1]))))*10
scenar_df$scenar_n<-as.numeric(apply(scenar_df[,c('Mdiff','Odiff','Ddiff')],1,max))

scenar_df$scenar_n2<-100*scenar_df$Mdiff+10*scenar_df$Odiff+1*scenar_df$Ddiff
scenar_df$scenar_type<-ifelse(scenar_df$scenar_n2==scenar_df$scenar_n |scenar_df$scenar_n2==10*scenar_df$scenar_n |scenar_df$scenar_n2==100*scenar_df$scenar_n ,colnames(scenar_df)[max.col(scenar_df[,c('Mdiff','Odiff','Ddiff')],ties.method='first')],'A')
scenar_df[scenar_df$scenar_n==0,'scenar_type']<-'REF'
attach(scenar_df)
if(length(scenar_df[scenar_df$scenar_type=="REF","scenar_type"])>1){scenar_df[scenar_df$scenar_type=="REF","scenar_type"][2]<-"REF2"}
scenar_type<-scenar_df$scenar_type
if(length(scenar_type) != length(scenar)){stop(paste("\n=====================\n=====================\n=====================\n scenarios definition is inconsistent. Number of scenario types : ",length(scenar_type), "Number of scenarios : ",length(scenar)))}


names<-paste(scenar, sep='_')	
	
sensi_overstocked	<-seq(10,100,by=10)
sensi_harvestdelayed<-seq(10,100,by=10)

runs		<-as.vector(names)
files_prefx <-paste(SIM_DIR, BiCaFFprefxIN, job_name, '_',runs,sep='')
files_prefxalldata <-paste(SIM_DIR, BiCaFFprefxIN2, job_name, '_',runs,sep='')
files_suffx <-c('run_params','sumGRECOs','sumspecies', 'sumspeciesGRECO', 'En_BE','BO', 'BI', 'BE','BO_no_recyc','BI_no_recyc','BE_no_recyc')
prefx_BaU<-files_prefx[i_BaU]


simus_description			<- outer(files_prefx,paste('.',files_suffx,'.csv',sep=''),paste,sep='')
simus_description<-cbind(simus_description,
                         outer(files_prefxalldata,paste('alldata_t_1','.csv',sep=''),paste,sep=''),
                         outer(files_prefxalldata,paste('alldata_t_2','.csv',sep=''),paste,sep=''),
                         outer(files_prefxalldata,paste('alldata_t_3','.csv',sep=''),paste,sep=''),
                         outer(files_prefxalldata,paste('alldata_t_4','.csv',sep=''),paste,sep=''),
                         outer(files_prefxalldata,paste('alldata_t_5','.csv',sep=''),paste,sep=''),
                         outer(files_prefxalldata,paste('alldata_t_6','.csv',sep=''),paste,sep='')
)

if(length(grep(job_name,last_run))==0){
	last_run<-paste(MOD_DIR ,'/run_details/', BiCaFFprefxIN, job_name, '_',runs[1],'.run_details.csv',sep='')
}
colnames(simus_description)	<- c(files_suffx,'t1','t2','t3','t4','t5','t6')	
simus_description			  <- data.frame(simus_description)
simus_description$runs	<- runs
simus_description$scenar<- scenar_type
simus_description$intens<- scenar_n
simus_description$M			<- gsub("^.*M([-0-9.]+)_.*$", 		"\\1", names)
simus_description$O			<- gsub("^.*O([0-9.]+)[_].*$", 	"\\1", names)
simus_description$D			<- gsub("^.*D([0-9.]+)_.*$", 		"\\1", names)
simus_description$U			<- gsub("^.*U([0-9.]+).*$", 		"\\1", names)
simus_description[simus_description$scenar=='REF','intens']<-10
nruns<-length(runs)
simus_description$simus_BiCaFF	<-paste('BiCaFF',seq(1,nruns),sep='')
if( length(grep('IC0',simus_description$runs))>0){
	idx_simus_nosensi 				<- grep('IC0',simus_description$runs)	
}else{
	idx_simus_nosensi<-seq(1,nruns)
}
IFN_FR_es						<-init_IFN_results()
IFN_FR_es$es_num		<-as.vector(as.factor(as.numeric(gsub("[^0-9]","", IFN_FR_es$species_codes))))
IFN_FR_es[as.numeric(IFN_FR_es$es_num)>50 ,'type']<-'R'
IFN_FR_es[as.numeric(IFN_FR_es$es_num)<50 |  as.numeric(IFN_FR_es$es_num)==98,'type']<-'F'
IFN_FR_es<-merge(IFN_FR_es,areas_by_species[areas_by_species$GRECO=='France',c('es_num','IFN_Superficie')])

# ==================================================================
# =================== read run details to have time length ========= 
tyears<-NULL
for(i in 1: length(names)){
	details<-read.csv(last_run)
	tyears<-append(tyears,details$tyears)
 }
if(length(unique(tyears))!=1){stop('several runs with different time lengths')}else if(tyears[1]>t_plot){tmax   <- floor(t_plot/5); tyears<-tyears[1]}else{tmax   <- floor(tyears[1]/5); tyears<-tyears[1]	}

# ==================================================================
# =================== define run colors ============================ 
style				<- set_colors(simus_description,names)
style_BiCaFF		<-style[2:length(style$colors),]
style_BiCaFF$lwds	<-as.numeric(as.vector(style_BiCaFF$lwds))/2
