# Tangle (shortcut = "Cc Cv t") allows to write the F-function_init_IGN.R file necessary to then "source()" functions directly from this .org file
  #Initialize
  plot                    <-'plot' # histogram
  # Coniferous plots cannot be coppices -> move to "mixed high stand and coppice" xx ça serait pas plus clair de les mettre en "high stand" ? De toutes façons c'est ce que le modèle va faire après, non ?
  placette[placette$type=='R' & placette$sfo==4,'sfo']<-3
  # Compute exploitability indices if they have not yet been computed
  if(length(placette$exploitability)==0){placette<-exploitability(placette)}

  # run details  will be saved as an output file with the same name
  # as output tables and figures to keep track of the run setup
  run_details                                             <-model_param_DE
  run_details$es_num                              <-as.vector(as.factor(as.numeric(gsub("[^0-9]","",run_details$es))))
  run_details[,c('ccd1','ccd2','ccd3','ccd4','ccd_copp','rthin','RDI_overstocked','RDI_mngt','RDI_self_thinning')]        <-NA

  # Number of study domains (nDE = number of species x number of ecological regions)
  nDE<-length(species_all$codes)*length(GRECO$GRECO_codes)#*(tmax+2)

  #species,GRECO,time,area,volume/ha,tot volume(area*vol/ha)
  df_template<-data.frame(
      es                      =rep(species_all$codes,length(GRECO$GRECO_codes)),
      es_num          =rep(species_all$es_num,length(GRECO$GRECO_codes)),
      es_name         =rep(species_all$names,length(GRECO$GRECO_codes)),
      GRECO           =rep(GRECO$GRECO_codes,each=length(species_all$codes)),
      time            =rep((0),each=length(species_all$codes),n=length(GRECO$GRECO_codes)),
      IFN_Superficie=numeric(nDE),
      nM                      =numeric(nDE),
      IV5M            =numeric(nDE),
      volM_ha         =numeric(nDE),
      vthinM_ha       =numeric(nDE),
      vharvM_hs_ha=numeric(nDE),
      vharvM_co_ha=numeric(nDE),
      nO                      =numeric(nDE),
      IV5O            =numeric(nDE),
      volO_ha         =numeric(nDE),
      vthinO_ha       =numeric(nDE),
      vharvO_hs_ha=numeric(nDE),
      vharvO_co_ha=numeric(nDE),
      nD                      =numeric(nDE),
      IV5D            =numeric(nDE),
      volD_ha         =numeric(nDE),
      vthinD_ha       =numeric(nDE),
      vharvD_hs_ha=numeric(nDE),
      vharvD_co_ha=numeric(nDE),
      nU                      =numeric(nDE),
      IV5U            =numeric(nDE),
      volU_ha         =numeric(nDE),
      vthinU_ha       =numeric(nDE),
      vharvU_hs_ha=numeric(nDE),
      vharvU_co_ha=numeric(nDE),
      IV5                     =numeric(nDE),
      vol_ha          =numeric(nDE),
      vthin_ha        =numeric(nDE),
      vharv_hs_ha     =numeric(nDE),
      vharv_co_ha     =numeric(nDE),
      stringsAsFactors = FALSE
  )
  #test_bilan<-df_bilan_volumes   harvested<-NULL

  # Energy-wood objectives
  # 2015 : 8.8+4*9ans/14ans ,2020,2025,2030
  # calculation based on target of increase of 4 Mtep per year between 2006 & 2020 with a value of 8.8Mtep from forest in 2006. 8.8 also in 2015 based on FCBA memento. Stable after 2020.
  Obj_BE<-c(9.7 ,12.8  ,16.8, 20.8, 20.8,20.8)

  # create space for parameters
  placette[,c('es_color_dark'             ,'es_name'              ,'es_color'     )]                                                              <-NA
  placette[,c('RDI_overstocked'   ,'ccd_cat'              ,'ccd_harv' ,'ccd_copp' ,'rthin')]                      <-NA
  placette[,c('NR_Dg_ess'                 ,'NR_IV5'               ,'NR_ir5_ess'   ,'NR_V' )]                                      <-NA
  placette[,c('IV5max'                    ,'Irmax'                ,'Dg_essmax')]                                                          <-NA
  placette[,c('IV5old'                    ,'Irold'                ,'Dgold')]                                                                      <-NA
  names_param0                                                    <-names(model_param_DE)[!(names(model_param_DE) %in% c('X','es','sfoparam','sensi'))]

  # List of 'non recensables' plots used to calculate starting values for plots after harvest. Taking only plots considered as not recensable with N above 500 to make sure that the values inventoried for age and Dg_ess are representative of the new growing stand and not the old remaining stand. Put a small value (7? not 5 so they are not on the same grid as the harvested ones) to age and diameter of non recensables with NA so they count when averaging the non-recensable characteristics xx un peu bizarre : soit tu mets à 7, soit à NA. D'après la suite du code, je laisserais les caractéristiques à "NA" si elles le sont ...
  NR_Nlim <- 200
  NR_idp  <-      placette[       placette$cac %in% c('NR','AA') & placette$age_1<10& placette$N_ess>NR_Nlim,'idp']
# NR_idp  <-      placette[       placette$cac %in% c('NR','AA')& placette$N_ess>NR_Nlim ,'idp']

#Problem: for some unrecensable plots missing data for age_1 => cannot calculate growth. Remove them from the dataset. 
 #placette[placette$idp %in% NR_idp & placette$N_ess< NR_Nlim,c('age_1','Dg_ess','V')]<-NA
 placette[placette$idp %in% NR_idp & is.na(placette$age_1)       ,'age_1'        ]<-7
 placette[placette$idp %in% NR_idp & is.na(placette$Dg_ess)      ,'Dg_ess'       ]<-7
 placette[placette$idp %in% NR_idp & is.na(placette$V)           ,'V'            ]<-7
placette<-placette[!is.na(placette$age_1),]

  placette[, c('IVi','Iri',names_param0)] <-NA
  placette$age_old                                                <-NA
  placette$EF                                                             <-0
  placette$RDIref<-placette$RDI
  EFB             <-data.frame(F=1.611, R=1.335)#expansion factor branches xx3
  EFT             <-data.frame(F=2.063, R=1.735)#expansion factor total (branches+roots) xx3
  BFTtoC  <-data.frame(F=0.535, R=0.361) #xx3
  WtoC    <-data.frame(F=0.546, R=0.438) # xx3
  placette[placette$type=='F','EF']<-EFB$F        #Expansion factors from Carbofor
  placette[placette$type=='R','EF']<-EFB$R
  placette$age_lim_RDI<-age_lim_RDI

     #====== NR specific (= non recensables) variables for recruitment. Not species dependent.
					#hist(data_es[data_es$idp %in% NR_idp,'Dg_ess'],breaks=100)
      NR_age          <-mean(placette[placette$idp %in% NR_idp,'age_1'],      na.rm=T)
      NR_Dg_ess       <-mean(placette[placette$idp %in% NR_idp,'Dg_ess'],     na.rm=T)
      NR_IV5          <-mean(placette[placette$idp %in% NR_idp,'IV5'],        na.rm=T)
      NR_ir5_ess      <-mean(placette[placette$idp %in% NR_idp,'ir5_ess'],    na.rm=T)
      NR_V            <-mean(placette[placette$idp %in% NR_idp,'V'],          na.rm=T)
      placette[placette$cac %in% c('AA','NR') & is.na(placette$age_1),'age_1']<-NR_age
  ################### FILL IN PLACETTE DATASET WITH SCENARIO-SPECIFIC VARIABLES :
  ################### START OF SPECIES LOOP -> put all criteria and necessary species-specific data in the overall table.



  for (es in species_all$codes ){
      es_num  <- as.vector(as.factor(as.numeric(gsub("[^0-9]","",es))))
      data_es <-placette[     placette$es_num == es_num   ,   ]
      n_data_es<-length(data_es$idp)
      print('=========================================================================')
      print(paste(es,' for ',tyears,' years ',tmax+2,'time slots (data0,modelt0,t1,...tmax )'))

	  ############### Define and fill out variables only dependent on species :

      #====== denomination variables
      es_name                 <- as.character(species_all$names                [species_all$codes==es])
      es_color                <- as.character(species_all$colors               [species_all$codes==es])
      es_color_dark           <- as.character(species_all$colors_dark  [species_all$codes==es])

#      NR_age          <-mean(data_es[data_es$idp %in% NR_idp,'age_1'],        na.rm=T)
#      NR_Dg_ess       <-mean(data_es[data_es$idp %in% NR_idp,'Dg_ess'],       na.rm=T)
#      NR_IV5          <-mean(data_es[data_es$idp %in% NR_idp,'IV5'],          na.rm=T)
#      NR_ir5_ess      <-mean(data_es[data_es$idp %in% NR_idp,'ir5_ess'],      na.rm=T)
#      NR_V            <-mean(data_es[data_es$idp %in% NR_idp,'V'],            na.rm=T)


      #====== management variables
      ccd_copp                <- as.numeric   (species_all$clear_cut_diam_coppice[species_all$codes==es]      )
      RDI_overstocked         <- species_all[species_all$es_num ==es_num,]$RDI_overstocked
      rthin                           <- species_all[species_all$es_num == es_num,]$rthin

      #====== growth variables
      rmort                           <- species_all[species_all$es_num == es_num,]$rmort

      ################### Fill out placettes for variables only dependent on species
      # fill in young and mature plots characteristics, mortality and management rules for a given species and sfo
      # age of young plots
      placette[placette$es_num == es_num ,c('NR_age') ]<-NR_age

      # species name, number and color code
      placette[placette$es_num == es_num ,c(  'es_name'       ,
					    'es_num'        ,
					    'es_color'      ,
					    'es_color_dark')]<-list(es_name,es_num,es_color,es_color_dark)

      # clear-cut diameter for coppices (ccd_copp), RDI threshold defining the "overstocked" category (RDI_overstocked), ratio of volume thinned per year (?) xx vérifier
      placette[placette$es_num == es_num ,c('ccd_copp',
					    'RDI_overstocked',
					    'rthin')]<-list(ccd_copp, RDI_overstocked,rthin)

      # Standing volume ratio of yearly mortality
      placette[placette$es_num == es_num,'rmort']<- rmort

      # Default characteristics of young stands
      placette[placette$es_num == es_num ,c(  'NR_IV5',
					    'NR_Dg_ess',
					    'NR_V',
					    'NR_ir5_ess')]<-list(   NR_IV5,
								 NR_Dg_ess,
								 NR_V,
								 NR_ir5_ess)

  #       placette[placette$es_num == es_num ,names_param0]<-paramsfo12
      # Define plot structure, maximum growth values and old stand characteristics in simlation
      for(i_sfo in seq(0,4)){
	  data_es_sfo     <-data_es[data_es$sfo %in% i_sfo,]
	  if(length(data_es_sfo$idp)>0){
	      # Define default plot structure in simlation (always "even-aged high stand" for coniferous, "even-aged high stand" for "undefined", "even-aged high stand" and "uneven-aged high stand" broadleaves and "coppice" for "high stand and coppice" and "coppice" broadleaves xx vérifie. Notamment il me semblait que les TSF étaient plutôt des futaies, mais dans le code semble faire ce que je décris ...
	      list_sfo_es     <- model_param_DE[      model_param_DE$es == es_num & !is.na(model_param_DE$Iri1),c('sfoparam')]
	      if(i_sfo %in% list_sfo_es){ref_sfo<-i_sfo}else{ref_sfo<-list_sfo_es[which.min(abs(i_sfo-list_sfo_es))]}

	      paramsfo        <- model_param_DE[      model_param_DE$es == es_num &
						      model_param_DE$sfoparam==ref_sfo,
						names_param0]

	      # Define maximum growth values
	      IV5max          <-as.numeric(quantile(data_es_sfo$IV5,0.99))
	      Irmax           <-as.numeric(quantile(data_es_sfo$ir5_ess,0.99,na.rm=T))
	      Dg_essmax       <-as.numeric(max(data_es_sfo$Dg_ess,na.rm=T))

	      placette[placette$es_num==es_num & placette$sfo==i_sfo ,c(
									  'IV5max',
									  'Irmax',
									  'Dg_essmax'     )]                      <- c(IV5max,Irmax,Dg_essmax)
	      placette[placette$es_num==es_num & placette$sfo==i_sfo ,names_param0]   <- paramsfo

	      # Define mature forest characteristics (age_old, Dgold, Irold, IV5old), parameter for the radial increment growth (Iri), and the clear-cut category (ccd_cat) and the related clear-cut diameter (ccd_harv). All these are specific to each fertility-class.
	      for(i_H100 in 1:4){
		  ccd_cat                         <- as.numeric   (species_all[species_all$es_num==es_num,paste('clear_cut_diam',i_H100,sep='')])
		  if(i_sfo==4){ccd_harv   <- ccd_copp     }else{  ccd_harv<-ccd_cat       }
		  data_es_sfo_H100                <- data_es_sfo[data_es_sfo$cac_H100==i_H100,c('idp','age_1','cac_H100','Dg_ess','ir5_ess','IV5')]
		  age_old                                 <- as.numeric(quantile(data_es_sfo_H100$age_1,0.95))
		  data_es_sfo_H100_old    <- data_es_sfo_H100[data_es_sfo_H100$age_1>=age_old,]
		  Dgold                                   <- mean(data_es_sfo_H100_old$Dg_ess,na.rm=T)
		  Irold                                   <- mean(data_es_sfo_H100_old$ir5_ess,na.rm=T)
		  IV5old                                  <- mean(data_es_sfo_H100_old$IV5,na.rm=T)
		  IVi                                             <- paramsfo[ ,as.character(paste('IVi',i_H100,sep=''))]
		  Iri                                             <- paramsfo[ ,as.character(paste('Iri',i_H100,sep=''))]
		  placette[placette$es_num==es_num & placette$sfo==i_sfo & placette$cac_H100==i_H100,c('age_old',                                                                                'Dgold',                                                                                   'Irold',                                                                                   'IV5old',
	   'IVi',
	   'Iri',
	   'ccd_cat',
	   'ccd_harv')] <- list(age_old,Dgold,Irold,IV5old,IVi,Iri,ccd_cat,ccd_harv)

	      }# end for iH100
	      if( length(placette[placette$es_num==es_num &placette$sfo==i_sfo &is.na(placette$Irold),'Irold']) >0){
		  placette[
		      placette$es_num==es_num &
		      placette$sfo==i_sfo &
		      is.na(placette$Irold),'Irold']<-mean(placette[
		      placette$es_num==es_num &
		      placette$sfo==i_sfo ,'Irold'],na.rm=T)

	      }
	  }#if length(data)>0
      }# end for i_sfo

      run_details[run_details$es_num== es_num,]$rthin <-species_all[species_all$codes==es,]$rthin
      run_details[run_details$es_num== es_num,]$RDI_overstocked<- unique(placette[!is.na(placette$ess_age_R) & placette$es_num == es_num,'RDI_overstocked'])
      run_details[run_details$es_num== es_num,]$rthin <-unique(placette[!is.na(placette$ess_age_R) & placette$es_num == es_num,'rthin'])
  }#end loop species####################

	  ### END ############# FILL IN PLACETTE DATASET WITH SCENARIO-SPECIFIC VARIABLES :
	  ### END ############    START OF SPECIES LOOP -> put all criteria and necessary species-specific data in the overall table.
